//+--------+
//+--------+
#property copyright "whatever"
#property link      "whoever"

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_color2  Red

//
//
//
//
//

extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalEMA=9;

//
//
//
//
//

double fastEMA[];
double slowEMA[];
double fastEMAd[];
double slowEMAd[];
double leader[];
double signal[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,leader);
      SetIndexBuffer(1,signal);
      SetIndexBuffer(2,fastEMA);
      SetIndexBuffer(3,slowEMA);
      SetIndexBuffer(4,fastEMAd);
      SetIndexBuffer(5,slowEMAd);
   IndicatorShortName("Leader MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=Bars-counted_bars;
 
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      fastEMA[i]  = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
      slowEMA[i]  = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
      fastEMAd[i] = Close[i] - fastEMA[i];
      slowEMAd[i] = Close[i] - slowEMA[i];
   } 
   for(i=0; i<limit; i++) leader[i]= (fastEMA[i] + iMAOnArray(fastEMAd,0,FastEMA,0,MODE_EMA,i)) -
                                     (slowEMA[i] + iMAOnArray(slowEMAd,0,SlowEMA,0,MODE_EMA,i));
 
   for(i=0; i<limit; i++) signal[i]=leader[i]-iMAOnArray( leader,0,SignalEMA,0,MODE_EMA,i);
   return(0);
}